//+------------------------------------------------------------------+
//|  mladen   mladenfx@gmail.com   Trend direction & force index.mq4 |
//| original metastock indicator made by Piotr Wojdylo               |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_maximum  1
#property indicator_minimum  -1
#property indicator_buffers  3
#property indicator_color1   Lime
#property indicator_color2   Red
#property indicator_color3   Red

extern int                TrendPeriod1            = 50;
extern int                TrendPeriod2            = 100;
extern int                TrendPeriod0            = 20;
int length;
double B0[],B0_c1[],B0_c2[],B1[],B2[],B3[];

int init(){
   IndicatorBuffers(6);
   SetIndexBuffer(0,B0);
   SetIndexBuffer(1,B0_c1);
   SetIndexBuffer(2,B0_c2);
   SetIndexBuffer(3,B1);
   SetIndexBuffer(4,B2);
   SetIndexBuffer(5,B3);
   //IndicatorShortName(NULL);
   length=TrendPeriod0*3;
   return(0);
}

int start(){int i,limit=Bars-IndicatorCounted()-1; double b12,b3,b4;

   for(i=limit;i>=0;i--){B1[i]=iCustom(NULL,0,"nonlag71_",TrendPeriod1,0,i);}// iMA(NULL,0,TrendPeriod1,0,ma_mode1,PRICE_HIGH,i);}
   for(i=limit;i>=0;i--){B2[i]=iCustom(NULL,0,"nonlag71_",TrendPeriod2,0,i);// iMAOnArray(B1,0,TrendPeriod2,0,ma_mode2,i);
                         b12=MathAbs(B1[i]-B2[i])/Point;
                         b3=(B1[i]-B1[i+1]+B2[i]-B2[i+1])/(2*Point);
                         B3[i]=b12*MathPow(b3,3);
                         b4=absHighest(i);
                         if(b4>0){B0[i]=B3[i]/b4;} else{B0[i]=0;}               }
   for(i=limit;i>=0;i--){if(B0[i]<0){B0_c1[i+1]=B0[i+1]; B0_c1[i]=B0[i];} else{B0_c1[i]=EMPTY_VALUE;}
                         if(B0[i+2]<0 && B0[i+1]>0 && B0[i]<0){B0_c1[i+2]=EMPTY_VALUE; B0_c2[i+3]=B0[i+3]; B0_c2[i+2]=B0[i+2];} }
   return(0);
}

double absHighest(int i2){
   double result=0;
   for(int i=length-1;i>=0;i--){if(result<MathAbs(B3[i2+i])){result=MathAbs(B3[i2+i]);}}
   return(result);
}